-- Copyright (C) 1999 Daniel Elphick and others
-- Licensed under Eiffel Forum Freeware License, version 1;
-- (see forum.txt)
--
indexing

   description "Template for all writers"
   author "Daniel Elphick <dre00r@ecs.soton.ac.uk>"
   cvs: "$Id"

deferred class WRITER

inherit

   GLOBALS

   VERSION

feature

   widget_tree: TAG_TREE
   indentation: INTEGER
   src_dir: STRING

   file: TEXT_FILE_WRITE
				
   indent is
      do
	 indentation := indentation + 1
      ensure
	 increased: indentation = old indentation + 1
      end
	
   outdent is
      require
	 indented: indentation > 0
      do
	 indentation := indentation - 1
      ensure
	 decrease: indentation = old indentation - 1
      end

   write_lines(lines: ARRAY[STRING]) is
      require
	 valid_lines: lines /= Void
      local
	 i: INTEGER
      do
	 from
	    i := 0
	 variant
	    lines.count - i
	 until
	    i >= lines.count
	 loop
	    write_line(lines @ i)
	    i := i + 1
	 end
      end
				
   write_line(line: STRING) is
      require
	 line_is_string: line /= Void
      local
	 i: INTEGER
      do
	 from
	    i := 0
	 variant
	    indentation - i
	 until
	    i >= indentation
	 loop
	    file.put_character('%T')
	    i := i + 1
	 end
	 file.put_string(line)
	 file.put_new_line
      end
			
   blank_line is
      do
	 file.put_new_line
      end

   eiffel_string(s: STRING): STRING is
      local
	 i: INTEGER
	 c: CHARACTER
      do
	 create Result.make(0)
	 from
	    i := 1
	 variant
	    s.count + 2 - i
	 until
	    i > s.count
	 loop
	    c := s @ i
	    if c = '%N' then
	       Result.append("%N")
	    elseif c = '%%' then
	       Result.append("%%")
	    elseif c = '%"' then
	       Result.append("%%%"")
	    elseif c = '%'' then
	       Result.append("%%%'")
	    else
	       Result.extend(c)
	    end
	    i := i + 1
	 end
      end
				
end
