-- Copyright (C) 1999 Daniel Elphick and others
-- Licensed under Eiffel Forum Freeware License, version 1;
-- (see forum.txt)
--
indexing

	description: "Writes source files for GtkList objects"
	author: "Daniel Elphick <dre00r@ecs.soton.ac.uk>"
	cvs: "$Id: gtk_list_writer.e,v 1.10 2002/08/26 02:32:48 DJAC Exp $"

class GTK_LIST_WRITER

inherit

	GTK_ATTRIBUTE_WRITER
		rename
			make as make_attribute
		redefine
			append_parent_creation, parent_inherit
		end

	CHILD

creation

	make

feature

	type:STRING is "GTK_LIST"
	
	make(attr_name: STRING; tree: TAG_TREE; src: STRING) is
		do
			make_attribute(attr_name, tree, src)
			selection_mode := widget_tree.get_string_from_field("selection_mode")
		end
			
	selection_mode: STRING

	append_parent_creation(code: ARRAY[STRING]) is
		do
			code.add_last("create " + name + ".make")
			code.add_last(name + ".set_selection_mode(" + selection_mode + ")")
			add_widget_code(code)
		end

   parent_inherit: INHERIT_LIST is
      local
         temp: KLASS
      do
         create Result.make
         create temp.make_with_name("GTK_SELECTIONMODE_ENUM")
         temp.add_undefine_clause("is_equal, copy")
         Result.add(temp)
      end

end
