-- Copyright (C) 1999 Daniel Elphick and others
-- Licensed under Eiffel Forum Freeware License, version 1;
-- (see forum.txt)
--
indexing

	description: "Writes source files for GtkMenuBar objects"
	author: "Daniel Elphick <dre00r@ecs.soton.ac.uk>"
	cvs: "$Id: gtk_menu_item_writer.e,v 1.13 2002/08/26 02:32:48 DJAC Exp $"

class GTK_MENU_ITEM_WRITER

inherit

	GTK_BIN_WRITER
		rename
			make as make_attribute
		redefine
			append_parent_creation
		end
	
creation

	make, make_in_popup

feature

		
	type: STRING is
		do
			Result := "GTK_MENU_ITEM"
		end

	make(attr_name: STRING; tree: TAG_TREE; src: STRING) is
		local
			submenu: TAG_TREE
		do
			make_attribute(attr_name, tree, src)
			label := tree.get_string_from_field("label")
			right_justify := tree.get_boolean_from_field("right_justify", False)
			submenu := tree.find_child("widget")
			if submenu /= Void then
				create_child_class(submenu, 1)
			end
		end

	make_in_popup(attr_name: STRING; tree: TAG_TREE; src: STRING) is
		do
			make(attr_name, tree, src)
			in_popup := True
		end

	label: STRING

	right_justify: BOOLEAN

	in_popup: BOOLEAN

	add_common_menu_item_code(code: ARRAY[STRING]) is
		do
			if right_justify then
				code.add_last(name + ".right_justify")
			end
			add_widget_code(code)
			if last_class /= Void then
				last_class.append_parent_creation(code)
				code.add_last(name + ".set_submenu(" + last_class.name + ")")
			end
		end

	append_parent_creation(code: ARRAY[STRING]) is
		do
			if label.is_empty then
				code.add_last("create " + name + ".make")
			else
				code.add_last("create " + name + ".make_with_label(%""+label+"%")")
			end
			if in_popup then
				code.add_last("Current.append(" + name + ")")
			end
			add_common_menu_item_code(code)
		end

end
