-- Copyright (C) 1999 Daniel Elphick and others
-- Licensed under Eiffel Forum Freeware License, version 1;
-- (see forum.txt)
--
indexing

	description: "Writes source files for Gtk?Scale objects"
	author: "Daniel Elphick <dre00r@ecs.soton.ac.uk>"
	cvs: "$Id: gtk_scale_writer.e,v 1.9 2002/08/26 02:33:20 DJAC Exp $"

deferred class GTK_SCALE_WRITER

inherit

	GTK_ATTRIBUTE_WRITER
		rename
			make as make_attribute
		redefine
			append_parent_declaration, append_parent_creation
		end
	
	CHILD

feature

	make(attr_name: STRING; tree: TAG_TREE; src: STRING) is
		do
			make_attribute(attr_name, tree, src)
			draw_value := widget_tree.get_boolean_string_from_field("draw_value")
			value_pos := widget_tree.get_string_from_field("value_pos")
			digits := widget_tree.get_integer_string_from_field("digits")
			policy := widget_tree.get_string_from_field("policy")
			value := widget_tree.get_real_string_from_field("value")
			lower := widget_tree.get_real_string_from_field("lower")
			upper := widget_tree.get_real_string_from_field("upper")
			step := widget_tree.get_real_string_from_field("step")
			page := widget_tree.get_real_string_from_field("page")
			page_size := widget_tree.get_real_string_from_field("page_size")
		end
			
	draw_value: STRING
	value_pos: STRING
	wrap: STRING
	digits: STRING
	policy: STRING
	value: STRING
	lower: STRING
	upper: STRING
	step: STRING
	page: STRING
	page_size: STRING
	
	append_parent_declaration(code: ARRAY[STRING]) is
		do
			code.add_last(name + "_adjustment: GTK_ADJUSTMENT")
			code.add_last(name + ": "+type)
		end

	append_parent_creation(code: ARRAY[STRING]) is
		do
			code.add_last("create " + name + "_adjustment.make("+ value + ", " +
				lower + ", " + upper + ", " + step + ", " + page + ", " +
				page_size + ")")
			code.add_last("create " + name + ".make("+name+"_adjustment)")
			code.add_last(name + ".set_digits("+digits+")")
			code.add_last(name + ".set_draw_value("+draw_value+")")
			code.add_last(name + ".set_value_pos("+value_pos+")")
			code.add_last(name + ".set_update_policy("+policy+")")
			add_widget_code(code)
		end

end
