-- Copyright (C) 1999 Daniel Elphick and others
-- Licensed under Eiffel Forum Freeware License, version 1;
-- (see forum.txt)
--
indexing

	description: "Writes source files for GtkToggleButton objects"
	author: "Daniel Elphick <dre00r@ecs.soton.ac.uk>"
	cvs: "$Id: gtk_toggle_button_writer.e,v 1.10 2002/08/26 02:33:20 DJAC Exp $"

class GTK_TOGGLE_BUTTON_WRITER

inherit

	GTK_ATTRIBUTE_WRITER
		rename
			make as make_attribute
		redefine
			append_parent_creation
		end

	CHILD

creation

	make

feature

	type: STRING is "GTK_TOGGLE_BUTTON"
	
	make(attr_name: STRING; tree: TAG_TREE; src: STRING) is
		do
			make_attribute(attr_name, tree, src)
			label := widget_tree.get_string_from_field("label")
			active := widget_tree.get_boolean_from_field("active", False)
		end
			
	label: STRING
	active: BOOLEAN

	append_parent_creation(code: ARRAY[STRING]) is
		do
			code.add_last("create " + name + ".make_with_label(%""+label+"%")")
			if active then
				code.add_last(name + ".set_state_down")
			else
				code.add_last(name + ".set_state_up")
			end
			add_widget_code(code)
		end
end
